SystemOrganization addCategory: #'XMLRPC-Server-Core'!

!SmallInteger methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:54'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	| w |
	w := WriteStream on: (String new: 50).
	w nextPutAll: '<value><i4>'; nextPutAll: self asString; nextPutAll: '</i4></value>'.
	^ w contents! !

!Float methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:51'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	| w | 
	w := WriteStream
				on: (String new: 50).
	w nextPutAll: '<value><double>';
		 nextPutAll: self asString;
		 nextPutAll: '</double></value>'.
	^ w contents! !

!True methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/15/2011 19:58'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	^ '<value><boolean>1</boolean></value>'! !

!Dictionary methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:50'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	| w |
	w := WriteStream
				on: (String new: 200).
	w nextPutAll: '<value><struct>'.
	self
		keysAndValuesDo: [:key :value | 
			w nextPutAll: '<member><name>';
				 nextPutAll: key asString;
				 nextPutAll: '</name>'.
			w nextPutAll: value asXMLRPCString;
				 nextPutAll: '</member>'].
	w nextPutAll: '</struct></value>'.
	^ w contents! !

!False methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/15/2011 19:50'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"

	^ '<value><boolean>0</boolean></value>'! !

!Array methodsFor: '*xmlrpc-server-core' stamp: 'SantiagoBragagnolo 9/20/2012 11:45'!
asXMLRPCHttpModule
	^ XMLRPCHttpModule for: self asDictionary.! !

!XMLRPCDateTime methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:57'!
asXMLRPCString
	| str |
	str := WriteStream on: (String new: 70).
	str nextPutAll: '<value><dateTime.iso8601>'; nextPutAll:
	self encodeISO8601; nextPutAll: '</dateTime.iso8601></value>';cr.
	^ str contents! !

!SequenceableCollection methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:53'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	| w |
	w := WriteStream on: (String new: 200).
	w nextPutAll: '<value><array><data>'.
	self
		do: [:each | w nextPutAll: each asXMLRPCString].
	w nextPutAll: '</data></array></value>'.
	^ w contents! !

!ByteString methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 3/26/2011 11:38'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	"TO-DO Revisar, está como String por ahora"
"	^ '<value>' , self asString , '</value>' "
	
	| w |
	w := WriteStream on: String new.
	w nextPutAll: '<value>'; nextPutAll: self asString; nextPutAll: '</value>'.
	^ w contents! !

!Stream methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:55'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver. A stream will be
	encoded as an base64 (mimeencoded) element."
	| w |
	w := WriteStream on: String new.
	w nextPutAll: '<value><base64>';
		 nextPutAll: (Base64MimeConverter mimeEncode: self) contents;
		 nextPutAll: '</base64></value>'.
	^ w contents! !

!Object methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:52'!
asXMLRPCString
	"answer a XMLRPC struct that includes all instanceVariables of the 
	receiver. A XMLRPC struct is represented as a dictionary in squeak"
	| d |
	d := Dictionary new.
	self class instVarNames
		do: [:each | d
				at: each asSymbol
				put: (self instVarNamed: each)].
	d size > 0 ifTrue: [^ d asXMLRPCString].
	^'<value>nil</value>'! !

Object subclass: #XMLRPCErrorHandler
	instanceVariableNames: 'error'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCErrorHandler commentStamp: '<historical>' prior: 0!
This is the error handler for XMLRPC errors!

!XMLRPCErrorHandler methodsFor: 'accessing' stamp: ''!
error
	"Answer the receiver's 'error'."

	^error! !

!XMLRPCErrorHandler methodsFor: 'accessing' stamp: ''!
error: anObject
	"Set the receiver's instance variable 'error' to be anObject."

	error := anObject! !

!XMLRPCErrorHandler methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/14/2012 11:54'!
errorMessage
	| str errorDict |
	errorDict := Dictionary new.
	
	(error class canUnderstand: #faultCode) ifTrue: [
		errorDict at: #faultCode put: error faultCode
	] ifFalse: [
		errorDict at: #faultCode put: 10
	]. 

	errorDict at: #faultString put: error messageText.
	
	str := WriteStream on: (String new: 1000).
	
	str 	nextPutAll: '<?xml version="1.0"?><methodResponse><fault>';
		nextPutAll: errorDict asXMLRPCString;
		nextPutAll: '</fault></methodResponse>'.
		
	^ str contents! !

Object subclass: #XMLRPCHttpModule
	instanceVariableNames: 'services'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

XMLRPCHttpModule class
	instanceVariableNames: 'defaultModule port service'!

!XMLRPCHttpModule commentStamp: '<historical>' prior: 0!
This comanche module handles incoming requests for a XMLRPC server!

XMLRPCHttpModule class
	instanceVariableNames: 'defaultModule port service'!

!XMLRPCHttpModule class methodsFor: 'construction' stamp: 'SantiagoBragagnolo 9/20/2012 11:00'!
for: aServiceDefinition 
	^ self new services: aServiceDefinition ; yourself.! !

!XMLRPCHttpModule methodsFor: 'logging' stamp: 'SantiagoBragagnolo 9/19/2012 17:17'!
initialize 
	super initialize.
	services := Dictionary new.
	! !

!XMLRPCHttpModule methodsFor: 'private' stamp: 'SantiagoBragagnolo 9/27/2012 16:58'!
invoke: aService with: anArrayOfParameters
	| association target selector |
	association := (services at: aService).
	target := association first key.
	selector := association first value.

	[
		^ target perform: selector withArguments: anArrayOfParameters asArray.
	] on: Error do: [
		:e |
		XMLRPCMethodError new signal: 'Message not understood by server class: ', e messageText.
	]! !

!XMLRPCHttpModule methodsFor: 'process' stamp: 'LucFabresse 2/1/2015 23:07'!
process: request 
	| xmldoc  parameters service response  |
	
	[
		xmldoc := XMLDOMParser parse: (request contents) readStream.		
		service := self resolveServiceName: xmldoc.
		parameters := self resolveParameters: xmldoc.
		response :=  (service = 'system.multicall') ifTrue: [
			(parameters at:1) collect: [ : i | 
				| s p |
				s :=  i at:'methodName'  .
				p := i at: 'params'.
				self invoke: s with: p. 	
			]
		] ifFalse: [ 
			self invoke: service with: parameters . 	
		 ].
		response := self returnableResponse: response.
		
	] on: Error do:[ 
		:e |
		 response := (XMLRPCErrorHandler new error: e) errorMessage.
	].
	^ response.! !

!XMLRPCHttpModule methodsFor: 'registering' stamp: 'SantiagoBragagnolo 9/19/2012 17:16'!
registerService: serviceName target: aTarget selector: aSelector 
	services at: serviceName put: { aTarget -> aSelector asSymbol }.! !

!XMLRPCHttpModule methodsFor: 'private' stamp: 'SantiagoBragagnolo 9/19/2012 17:28'!
resolveParameters: xmldoc
	^((xmldoc firstElement) elementAt: #params ) elements inject: OrderedCollection new into: [
		:parameters :parameter |
		parameters add: (XMLRPCDecoder new decode: parameter); yourself.
	].! !

!XMLRPCHttpModule methodsFor: 'private' stamp: 'SantiagoBragagnolo 9/19/2012 17:28'!
resolveServiceName: xmldoc
	^ ((xmldoc firstElement elementAt: #methodName) contentString).	! !

!XMLRPCHttpModule methodsFor: 'private' stamp: 'SantiagoBragagnolo 1/25/2013 10:55'!
returnableResponse: aResult
	| stream |
	stream := WriteStream on: String new.
	stream nextPutAll: '<?xml version="1.0"?><methodResponse><params><param>'.
	stream nextPutAll: aResult asXMLRPCString.
	stream nextPutAll: '</param></params></methodResponse>'.
	
	
	^ stream contents.
	! !

!XMLRPCHttpModule methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2012 17:42'!
services: aServiceDefinition
	services := aServiceDefinition asDictionary.! !

Object subclass: #XMLRPCServer
	instanceVariableNames: 'port server modules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

XMLRPCServer class
	instanceVariableNames: 'DefaultClass'!

XMLRPCServer class
	instanceVariableNames: 'DefaultClass'!

!XMLRPCServer class methodsFor: 'construction' stamp: 'SantiagoBragagnolo 1/25/2013 11:05'!
defaultClass 
	^ DefaultClass.! !

!XMLRPCServer class methodsFor: 'construction' stamp: 'SantiagoBragagnolo 1/25/2013 11:06'!
defaultClass: aClass 
	DefaultClass := aClass.! !

!XMLRPCServer class methodsFor: 'construction' stamp: 'SantiagoBragagnolo 1/25/2013 11:06'!
initialize
	self defaultClass: XMLRPCZNServer.! !

!XMLRPCServer class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/20/2012 10:22'!
startOn: aPort
	^ self startOn: aPort with: Dictionary new.

! !

!XMLRPCServer class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 11:05'!
startOn: aPort with: aModuleDictinaryDefinition
	^ self defaultClass port: aPort; modules: aModuleDictinaryDefinition; start ; yourself.

! !

!XMLRPCServer class methodsFor: 'construction' stamp: 'SantiagoBragagnolo 1/25/2013 11:09'!
startOn: aPort with: aModuleDictinaryDefinition at: anAlias
	^ self defaultClass new port: aPort; at: anAlias put: aModuleDictinaryDefinition ; start ; yourself.

! !

!XMLRPCServer methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2012 17:03'!
addModules: aModuleDefinition 
	modules := modules union: aModuleDefinition asDictionary.! !

!XMLRPCServer methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2012 16:41'!
at: uri put: aModule

	modules at: uri put: aModule.! !

!XMLRPCServer methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 1/25/2013 10:42'!
createServer 
	^ self subclassResponsibility.! !

!XMLRPCServer methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 9/20/2012 10:58'!
destroy
	self stop.
	server := nil.
	! !

!XMLRPCServer methodsFor: 'initialize-release' stamp: 'SantiagoBragagnolo 9/19/2012 16:42'!
initialize 
	super initialize.
	modules := Dictionary new.
	
! !

!XMLRPCServer methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2012 16:54'!
modules: aModuleDefinition 
	modules := aModuleDefinition asDictionary.
	! !

!XMLRPCServer methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2012 16:50'!
port
	^port.! !

!XMLRPCServer methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/19/2012 16:32'!
port: aPort
	port := aPort. 
! !

!XMLRPCServer methodsFor: 'control' stamp: 'SantiagoBragagnolo 1/25/2013 10:40'!
start

	server ifNil:[
		self createServer.
	].

	server start.
	
	! !

!XMLRPCServer methodsFor: 'control' stamp: 'SantiagoBragagnolo 1/25/2013 10:58'!
stop
	self subclassResponsibility.! !

XMLRPCServer subclass: #XMLRPCZNServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCZNServer methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 12:11'!
createServer
	| delegate |
	
	server := ZnServer on: self port.
	delegate := ZnDispatcherDelegate new.
	
	modules keysAndValuesDo: [
		:key :value | 
		delegate map: key to: [ :request :response |  
			response entity: (ZnStringEntity xml: (value process: request)) ] .	
	].

	server delegate: delegate.
	
! !

!XMLRPCZNServer methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 10:59'!
stop
	server ifNotNil: [
		server stop.
		server := nil
	].! !

Object subclass: #XMLRPCServerRequest
	instanceVariableNames: 'methodCall params targetURI'
	classVariableNames: 'Receivers'
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCServerRequest commentStamp: '<historical>' prior: 0!
This class holds all information about a XMLRPC request an coordinates the computation of a XMLRPC methodcall!

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/17/2012 15:57'!
cleanUpReceiverDictionary
	" deletes references to obsolete classes from the 'Receivers' dictionary"
	| removeThem |
	
	self debug: ['Cleaning up receiving dictionary: ' , self receivers ].
	removeThem := self receivers 	select: [ : each | each isObsolete ].
	removeThem keysDo: [ : key | self receivers removeKey: key ].
	! !

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'LucFabresse 2/2/2015 08:20'!
fromRequest: xmlString 
	| xmldoc r parameters relatedSelector |
		
	r := self new.
	parameters := OrderedCollection new.
	xmldoc := XMLDOMParser parseDocumentFrom: xmlString readStream.
	
	relatedSelector := ((xmldoc firstElement elementAt: #methodName) contentString).
	
	r methodCall: relatedSelector.	
	[
		((xmldoc firstElement) elementAt: #params ) elements do: [
			:each | 
			parameters add: (XMLRPCDecoder new decode: each)
		].
		
	] on: Error do: [
		XMLRPCRequestError new signal: 'Could not decode request'
	].

	r params: parameters.
	^ r! !

!XMLRPCServerRequest class methodsFor: 'class initialization' stamp: ''!
initialize
	Receivers := Dictionary new.! !

!XMLRPCServerRequest class methodsFor: 'accessing' stamp: 'SantiagoBragagnolo 9/14/2012 11:56'!
receivers
	^Receivers ifNil: [Receivers := Dictionary new].! !

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 1/25/2013 12:15'!
registerService: serviceName class: aClass selector: aSelector 
	self receivers at: serviceName asSymbol put: aClass -> aSelector! !

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'LucFabresse 2/2/2015 08:19'!
removeAllServices
	self receivers removeAll.! !

!XMLRPCServerRequest class methodsFor: 'as yet unclassified' stamp: 'LucFabresse 2/2/2015 08:20'!
removeService: aXMLRPCService
	self receivers removeKey: aXMLRPCService asSymbol! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
methodCall
	"Answer the receiver's 'methodCall'."

	^methodCall! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
methodCall: anObject
	"Set the receiver's instance variable 'methodCall' to be anObject."

	methodCall := anObject! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
params
	"Answer the receiver's 'params'."

	^params! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
params: anObject
	"Set the receiver's instance variable 'params' to be anObject."

	params := anObject! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
targetURI
	"Answer the receiver's 'targetURI'."

	^targetURI! !

!XMLRPCServerRequest methodsFor: 'accessing' stamp: ''!
targetURI: anObject
	"Set the receiver's instance variable 'targetURI' to be anObject."

	targetURI := anObject! !

Object subclass: #XMLRPCService
	instanceVariableNames: 'servers'
	classVariableNames: 'instance'
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCService class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/25/2012 17:03'!
atPort: aPort serve: aModuleDefinition at: anAlias
	^ self instance atPort: aPort serve: aModuleDefinition at:anAlias.
! !

!XMLRPCService class methodsFor: 'loggin' stamp: 'SantiagoBragagnolo 9/20/2012 10:32'!
destroy
	self instance destroy.! !

!XMLRPCService class methodsFor: 'service' stamp: 'SantiagoBragagnolo 9/26/2012 15:18'!
destroy: aPort
	^ self instance destroy: aPort.! !

!XMLRPCService class methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2012 16:57'!
instance
	^ instance ifNil: [ instance := self new. ].
	! !

!XMLRPCService class methodsFor: 'loggin' stamp: 'SantiagoBragagnolo 9/20/2012 10:31'!
startAll 
	self instance startAll ! !

!XMLRPCService class methodsFor: 'service' stamp: 'SantiagoBragagnolo 9/26/2012 13:17'!
stop: aPort
	^ self instance stop: aPort.! !

!XMLRPCService class methodsFor: 'loggin' stamp: 'SantiagoBragagnolo 9/20/2012 10:32'!
stopAll
	self instance stopAll! !

!XMLRPCService methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/20/2012 11:42'!
atPort: aPort serve: aModuleDefinition at:anAlias
	| relatedServer |
	
	relatedServer := servers at: aPort ifAbsentPut: [
		XMLRPCServer startOn: aPort with: aModuleDefinition at: anAlias.
	].


	
	! !

!XMLRPCService methodsFor: 'logging' stamp: 'LucFabresse 2/1/2015 23:06'!
destroy
	self stopAll.
	servers valuesDo: #destroy.
	self initialize.! !

!XMLRPCService methodsFor: 'service' stamp: 'SantiagoBragagnolo 10/7/2014 19:09'!
destroy: aPort
	self halt.
	servers at: aPort ifPresent: [ :server | 
		server destroy.
		servers removeKey: aPort.
	].
	! !

!XMLRPCService methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/19/2012 16:58'!
initialize 
	super initialize.
	servers := Dictionary new.
	! !

!XMLRPCService methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/20/2012 10:26'!
start: aPort
	servers at: aPort  ifPresent:  [
		:server | 
		server start. 
	].

! !

!XMLRPCService methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 9/20/2012 10:25'!
startAll
	servers valuesDo: #start.! !

!XMLRPCService methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/17/2014 16:02'!
stop: aPort
	servers at: aPort  ifPresent:  [
		:server | 
		server stop. 
		servers removeKey: aPort.
	].

! !

!XMLRPCService methodsFor: 'as yet unclassified' stamp: 'SantiagoBragagnolo 10/29/2014 21:31'!
stopAll
	servers valuesDo: #stop.
	servers removeAll.! !

Error subclass: #XMLRPCError
	instanceVariableNames: 'faultCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCError commentStamp: '<historical>' prior: 0!
This is a generic error, it is raised if an unknown error has been detected.!

XMLRPCError subclass: #XMLRPCClassNotFoundError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCClassNotFoundError commentStamp: '<historical>' prior: 0!
The request Class wasn't found!

!XMLRPCClassNotFoundError methodsFor: 'as yet unclassified' stamp: ''!
faultCode
	^ 1! !

!XMLRPCError methodsFor: 'accessing' stamp: ''!
faultCode
	"Answer the receiver's 'faultCode'."
	^ faultCode ifNil: [ ^0]! !

!XMLRPCError methodsFor: 'accessing' stamp: ''!
faultCode: anObject
	"Set the receiver's instance variable 'faultCode' to be anObject."

	faultCode := anObject! !

XMLRPCError subclass: #XMLRPCMethodError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCMethodError methodsFor: 'as yet unclassified' stamp: ''!
faultCode
	^ 2! !

XMLRPCError subclass: #XMLRPCRequestError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCRequestError commentStamp: '<historical>' prior: 0!
An error raised if a malformed request was found!

!XMLRPCRequestError methodsFor: 'as yet unclassified' stamp: ''!
faultCode
	^ 3! !

XMLRPCError subclass: #XMLRPCReturnError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Core'!

!XMLRPCReturnError commentStamp: '<historical>' prior: 0!
An error occured while encoding a methodresponse!

!XMLRPCReturnError methodsFor: 'as yet unclassified' stamp: ''!
faultCode
	^ 4! !

!String methodsFor: '*XMLRPC-Server-Core' stamp: 'GermanArduino 2/16/2011 09:55'!
asXMLRPCString
	"answer a XMLRPC representation of the receiver"
	| w |
	w := WriteStream on: String new.
	w nextPutAll: '<value>'; nextPutAll: self asString; nextPutAll: '</value>'.
	^ w contents! !
XMLRPCServerRequest initialize!
XMLRPCServer initialize!
